$infilename = shift(@ARGV);
unless ($infilename =~ /\.bbl$/i) {
	$infilename .= ".bbl";
}

open(IN, "< $infilename") or die("file open error");
@in = <IN>;
close(IN);

foreach (@in) {
	if (/^  /) {
		s/^  / /;
		my $temp = pop(@temp);
		chomp($temp);
		$temp .= $_;
		push(@temp, $temp);
	} else {
		push(@temp, $_);
	}
}

open(OUT, "> $infilename") or die("file write error");
foreach (@temp) {
	if (/^[A-Z]\./) {
		s/\.(\r?\n?)$/, $1/;
		s/((?:[A-Z]\.[~ ])+)([^,]+), /$2 $1, /g;
		s/([A-Z])\.[~ ]/$1/g;
		s/^((?:[^,]+, ){3})(?:[^,]+, ){4,}/$1\\textit\{et~al\.\}/;
		s/, (\r?\n?)$/$1/;
		s/,( \\textit\{et~al\.\})/$1/;
	} elsif (/\\newblock \d+,/) {
		s/\\newblock (\d+),/\\newblock \($1\)/;
	} elsif (/\\newblock \{\\em [^\{\}]+\}, \w+, /) {
		s/(\\newblock \{\\em [^\{\}]+\}, )(\w+)/$1\\textbf\{$2\}/;
	} elsif (/\\newblock In /) {
		s/(\\newblock In) /$1: /;
		s/(\(eds?\. [^\(\)]+)\)/$1, \)/;
		s/((?:[A-Z]\.[~ ])+)([^,]+), /$2 $1, /g;
		s/([A-Z])\.[~ ]/$1/g;
		s/(\(eds?\. )((?:[^\(\),]+, ){3})(?:[^\(\),]+, ){4,}/$1$2\\textit\{et~al\.\}/;
		s/(\(eds?\. [^\(\)]+), \)/$1\)/;
		s/, (\\textit\{et~al\.\})/$1/;
	} elsif (/^\\begin\{thebibliography\}/) {
		s/(.+)/$1\n\\normalsize/;
	}
	print(OUT);
}
